Attribute VB_Name = "Decode_Mul"
Public Declare Function SetPixel Lib "gdi32" (ByVal hDc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Public UoPath As String, TilePath As String

Dim FileNum As Integer

Dim LookUpTableArt() As Integer
Dim ImageColors() As Integer
Dim iHeader As Long
Dim iWidth As Integer
Dim iHeight As Integer
Dim xOffset As Integer
Dim i As Integer, X As Integer, Y As Integer, Size As Long
Dim xRun As Integer, AX As Integer, AY As Integer

Dim LookUp As Long
Dim Length As Long
Dim Extra As Long

Private Function Color16To32(Color16 As Integer) As Long   '  16   32   '
    Color16To32 = RGB(((((Color16 And &H7C00) / &H400) / &H1F) * &HFF), ((((Color16 And &H3E0) / &H20) / &H1F) * &HFF), (((Color16 And &H1F) / &H1F) * &HFF))
End Function

Public Sub Load_Land_Tile(PicHdc As Long, PicID As Long, UoPath As String)   '  ART LAND '
    FileNum = FreeFile(0)
    Open UoPath & "artidx.mul" For Binary Access Read As FileNum
    Get FileNum, PicID * 12 + 1, LookUp
    Get FileNum, Seek(FileNum), Length
    Get FileNum, Seek(FileNum), Extra
    Close FileNum
    If LookUp = -1 Then Exit Sub
    Open UoPath & "art.mul" For Binary Access Read As FileNum
    ReDim ImageColors(1011)
    Get FileNum, LookUp + 1, ImageColors()
    Close FileNum
    X = 21: Y = 0: AX = 0
    For Y = 0 To 21
        For X = 1 To (Y + 1) * 2
            Call SetPixel(PicHdc, (20 - Y) + X, Y, Color16To32(ImageColors(AX)))
            AX = AX + 1
        Next X
    Next Y
    For Y = 21 To 0 Step -1
        For X = 1 To (Y + 1) * 2
            Call SetPixel(PicHdc, (20 - Y) + X, 43 - Y, Color16To32(ImageColors(AX)))
            AX = AX + 1
        Next X
    Next Y
End Sub

Public Sub Load_Art(PicHdc As Long, PicID As Long, UoPath As String)   '  ART STATIC '
    FileNum = FreeFile(0)
    Open UoPath & "artidx.mul" For Binary Access Read As FileNum
    Get FileNum, (PicID + &H4000) * 12 + 1, LookUp
    Get FileNum, Seek(FileNum), Length
    Get FileNum, Seek(FileNum), Extra
    Close FileNum
    If LookUp = -1 Then Exit Sub
    Open UoPath & "art.mul" For Binary Access Read As FileNum
    Get FileNum, LookUp + 1, iHeader
    Get FileNum, Seek(FileNum), iWidth
    Get FileNum, Seek(FileNum), iHeight
    ReDim LookUpTableArt(0 To iHeight - 1)
    Get FileNum, Seek(FileNum), LookUpTableArt()
    X = 0: Y = 0: xRun = 0: xOffset = 0
    Size = Seek(FileNum)
    Do While Y < iHeight - 1
        If xRun + xOffset <> 0 Then
            X = xOffset
next_line:
            ReDim ImageColors(0 To xRun - 1)
            Get FileNum, Seek(FileNum), ImageColors
            For i = 0 To UBound(ImageColors())
                Call SetPixel(PicHdc, X, Y - 1, Color16To32(ImageColors(i)))
                X = X + 1
            Next i
            Get FileNum, Seek(FileNum), AX
            If AX > 0 And AX < iWidth Then
                Get FileNum, Seek(FileNum), xRun
                X = X + AX
                GoTo next_line
            End If
        End If
        Get FileNum, Size + LookUpTableArt(Y) * 2, xOffset
        Get FileNum, Seek(FileNum), xRun
        X = 0
        Y = Y + 1
    Loop
    Close FileNum
End Sub


